unit IE_Connected;
{***************************************************************************}
{ Author                                                                    }
{   Kevin S. Gallagher                                                      }
{ Description                                                               }
{   Some keys in the registry can not be opened with TRegistry because of   }
{   how they were written. In this case we need to go directly to the API   }
{   level.  In this case the key gets locked while online for local PCs.    }
{***************************************************************************}
interface

uses
  Windows, Messages, SysUtils, Controls, Dialogs, StdCtrls; //, Registry;

function IsConnected: boolean ;

implementation

function IsConnected: boolean ;
const
  cMsg      = 'Place your error message here ' ;  { for demoing only }
  sSubKey   = 'System\CurrentControlSet\Services\RemoteAccess' ;
  sKeyValue = 'Remote Connection' ;
var
  pKey: hKey ;
  lpData,
  DataSize: Longint ;
begin
  lpData := $0 ;
  if RegOpenKeyEx(HKEY_LOCAL_MACHINE,sSubKey,0,KEY_QUERY_VALUE,pKey) = 0 then
  begin
    try
      DataSize := Sizeof(lpData);
      if RegQueryValueEx(pKey,sKeyValue,nil,nil,@lpData,@DataSize) <> 0  then
        raise Exception.Create(cMsg + #13 + SysErrorMessage(GetLastError)) ;
    finally
      RegCloseKey(pKey) ;
    end;
    if lpData > 0 then
      Result := True
    else
      Result := False ;
  end else
    raise Exception.Create(cMsg + #13 + SysErrorMessage(GetLastError)) ;
end ;

end.
