unit MS_Word_Info;

{***************************************************************************}
{ Description                                                               }
{   Code to show how to figure out if an application is installed and what  }
{   version the application is. It is up to the calling routine to decide   }
{   if the program actually exist, here we provide the version and path and }
{   exe-name. From this information you could use FileExist to see if the   }
{   file resides were it should and could get internal version information  }
{   using the code in DCOM_MDAC unit, or any file version component.        }
{   Note there are two reads done to get the information we need. Also note }
{   how the TRegistry variable is set to NIL so we bypass compiler hints.   }
{                                                                           }
{   Exception handling could be handled differently, but that is not what we}
{   are here for. You could take it upon yourself to tweak it.              }
{***************************************************************************}

//KeyExists('HKEY_CLASSES_ROOT\CLSID\{00020906-0000-0000-C000-000000000046});

interface

uses
  Windows, Messages, SysUtils, Dialogs, Registry;

function GetMicrosoftWordLocation(var cVersion:String) : String;

implementation

function GetMicrosoftWordLocation(var cVersion:String) : String;
const
  cKEY1 = 'SOFTWARE\Classes\.doc' ;
  cKEY2 = 'SOFTWARE\Classes\%s\protocol\StdFileEditing\Server' ;
var
  Reg : TRegistry;
  strValue,strRegKey : String;
begin

  Reg := nil ;
  try
    Reg := TRegistry.Create ;
  except on E:Exception do
  begin
      Reg.Free ;
      MessageDlg(E.Message + #13 + 'TRegistry.Create;',mtError, [mbOK], 0) ;
      raise ;
    end;
  end;

  Reg.RootKey:= HKEY_LOCAL_MACHINE ;

  strRegKey := cKEY1 ;

  if Reg.OpenKeyReadOnly(strRegKey) = True then
  begin
    strValue := Reg.ReadString ( '' ) ;
    Reg.CloseKey;
    if( strValue <> '' ) then
    begin
      if( strValue = 'Word.Document.6' ) then
      begin
        cVersion := '95' ;
      end else if( strValue = 'Word.Document.8' ) then
      begin
        cVersion:= '97' ;
      end else
      begin
        //WORD_VERSION_UNKNOWN or later version
        cVersion := '' ;
      end ;

      strRegKey := Format(cKEY2,[strValue]) ;
      if Reg.OpenKeyReadOnly(strRegKey) then
      begin
        Result := Reg.ReadString ( '' );
      end else
      begin
        MessageDlg('Cannot find the location of your version of MicroSoft Word',
          mtError, [mbOK], 0) ;
        Result := '' ; // empty string as location has not been found
      end
    end;
  end ;


  Reg.Free ;

end ;

end.
