unit RunEntries;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Registry ;

type
  TfrmRunApps = class(TForm)
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    cmdClose: TButton;
    ListView1: TListView;
    procedure cmdCloseClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmRunApps: TfrmRunApps;

implementation

{$R *.DFM}

procedure TfrmRunApps.cmdCloseClick(Sender: TObject);
begin
  Close ;
end;

{--------------------------------------------------------
  Get entries from the registry for applications and
  services which run when Windows starts up.
 -------------------------------------------------------}
procedure TfrmRunApps.FormCreate(Sender: TObject);
  procedure Add(const ACaption, AValue : string) ;
  begin
    with ListView1.Items.Add do
    begin
      Caption := ACaption ;
      SubItems.Add (AValue) ;
    end ;
  end ;
const
  aRun = 'Software\Microsoft\Windows\CurrentVersion\Run' ;
  aRunService = 'Software\Microsoft\Windows\CurrentVersion\Run' ;
var
  reg: TRegistry ;
  rInfo: TRegKeyInfo ;
  aList: TStringList ;
  i: Integer ;
begin
  reg := TRegistry.Create ;
  aList := TStringList.Create ;

  ListView1.Items.BeginUpdate ;

  try
    reg.RootKey := HKEY_LOCAL_MACHINE ;

    { Since we are not changing anything we open the key in read only mode }
    if reg.OpenKeyReadOnly(aRun) then
    begin
      { Using GetKeyInfo we can determine if there are values to get
        prior to attempting to get values which may not exist. }
      if reg.GetKeyInfo(rInfo) then
        if rInfo.NumValues >0 then
        begin
          Add('Run','') ;
          { Populate the TStringList with a list of values within the
            current key }
          Reg.GetValueNames(aList) ;
          for i := 0 to rInfo.NumValues -1 do
          begin
            Add(aList.Strings[i],Reg.ReadString(aList.Strings[i])) ;
          end ;
        end else
          Add('(Default Value)','(Value not set.)') ;
          
      reg.CloseKey ;
    end ;

    aList.Clear ;

    if Reg.OpenKeyReadOnly(aRunService) then
    begin
      if reg.GetKeyInfo(rInfo) then
        if rInfo.NumValues >0 then
        begin
          Add('RunServices','') ;
          Reg.GetValueNames(aList) ;
          for i := 0 to rInfo.NumValues -1 do
            Add(aList.Strings[i],Reg.ReadString(aList.Strings[i])) ;
        end else
          Add('(Default Value)','(Value not set.)') ;

      reg.CloseKey ;
      
    end ;
  finally
    reg.CloseKey ;
    reg.Free ;
    aList.Free ;
    ListView1.Items.EndUpdate ;

    { The first item in the ListView }
    with ListView1 do
      Selected := FindCaption(0,'Run',False,True,True);

    ActiveControl := ListView1 ;

  end ;
end;

end.
